Loading...
Searching...
No Matches
juce::UndoableAction Class Referenceabstract

`#include <juce_UndoableAction.h>`

## Public Member Functions

virtual | ~UndoableAction ()=default
virtual bool | perform ()=0
virtual bool | undo ()=0
virtual int | getSizeInUnits ()
virtual UndoableAction * | createCoalescedAction (UndoableAction *nextAction)

## Protected Member Functions

| UndoableAction ()=default

## Detailed Description

Used by the UndoManager class to store an action which can be done and undone.

See also
  UndoManager

Definition at line 38 of file juce_UndoableAction.h.

## Constructor & Destructor Documentation

## UndoableAction()

juce::UndoableAction::UndoableAction | ( |  | ) |

protected default

Creates an action.

Referenced by createCoalescedAction().

## ~UndoableAction()

virtual juce::UndoableAction::~UndoableAction | ( |  | ) |

virtual default

Destructor.

## Member Function Documentation

## createCoalescedAction()

UndoableAction * juce::UndoableAction::createCoalescedAction | ( | UndoableAction * | nextAction | ) |

virtual

Allows multiple actions to be coalesced into a single action object, to reduce storage space.

If possible, this method should create and return a single action that does the same job as this one followed by the supplied action.

If it's not possible to merge the two actions, the method should return a nullptr.

Definition at line 29 of file juce_UndoableAction.cpp.

## getSizeInUnits()

virtual int juce::UndoableAction::getSizeInUnits | ( |  | ) |

inline virtual

Returns a value to indicate how much memory this object takes up.

Because the UndoManager keeps a list of UndoableActions, this is used to work out how much space each one will take up, so that the UndoManager can work out how many to keep.

The default value returned here is 10 - units are arbitrary and don't have to be accurate.

See also
  UndoManager::getNumberOfUnitsTakenUpByStoredCommands, UndoManager::setMaxNumberOfStoredUnits

Definition at line 88 of file juce_UndoableAction.h.

## perform()

virtual bool juce::UndoableAction::perform | ( |  | ) |

pure virtual

Overridden by a subclass to perform the action.

This method is called by the UndoManager, and shouldn't be used directly by applications.

Be careful not to make any calls in a perform() method that could call recursively back into the UndoManager::perform() method

Returns
  true if the action could be performed.

See also
  UndoManager::perform

## undo()

virtual bool juce::UndoableAction::undo | ( |  | ) |

pure virtual

Overridden by a subclass to undo the action.

This method is called by the UndoManager, and shouldn't be used directly by applications.

Be careful not to make any calls in an undo() method that could call recursively back into the UndoManager::perform() method

Returns
  true if the action could be undone without any errors.

See also
  UndoManager::perform

The documentation for this class was generated from the following files:

- juce_UndoableAction.h
- juce_UndoableAction.cpp